# Plot of the centers of regions with bad accuracy

# Worst sMAPE in regions: 1, 4, 9, 16, 28, 29
# Best sMAPE in regions: 11, 13, 19, 20, 24, 25, 27

import dask.dataframe as dd
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
from IPython.display import display
import folium
from folium.features import DivIcon
from datetime import datetime
import time
import seaborn as sns
import os
import math
import gpxpy.geo
from sklearn.cluster import MiniBatchKMeans, KMeans

print("Hey I am running !")

TEST_DATA_URL = "C:/Users/Matteo/Desktop/Python_Programs/LaFi_Train_DF_XGBoost_6_2015_0703_NWA_Weather_NOFFT_Hourly.csv"

test_dataset = pd.read_csv(TEST_DATA_URL, header = 0)

print("Hey I am running 1")

NUM_CLUSTERS = 30;

print("Hey I am running 2")


# column 5 and 6 should have latitude and longitude
n = 20 #number of clusters
centerOfRegions = np.empty([n,2])
#print('Latitude = {}'.format(test_dataset.at[150,'Latitude']))

# WORST sMAPE
centerOfRegions[0,0] = test_dataset.at[150,'Latitude'] # cluster 1
centerOfRegions[0,1] = test_dataset.at[150,'Longitude'] 
centerOfRegions[1,0] = test_dataset.at[1600,'Latitude'] # cluster 4
centerOfRegions[1,1] = test_dataset.at[1600,'Longitude'] 
centerOfRegions[2,0] = test_dataset.at[4200,'Latitude'] # cluster 9
centerOfRegions[2,1] = test_dataset.at[4200,'Longitude']
centerOfRegions[3,0] = test_dataset.at[7600,'Latitude'] # cluster 16: 7600 / 14
centerOfRegions[3,1] = test_dataset.at[7600,'Longitude']
centerOfRegions[4,0] = test_dataset.at[13600,'Latitude'] # cluster 28: 13600 /15
centerOfRegions[4,1] = test_dataset.at[13600,'Longitude']
centerOfRegions[5,0] = test_dataset.at[14150,'Latitude'] # cluster 29: 14150 /cluster 8
centerOfRegions[5,1] = test_dataset.at[14150,'Longitude']

# BEST sMAPE
centerOfRegions[6,0] = test_dataset.at[530,'Latitude'] # cluster 2
centerOfRegions[6,1] = test_dataset.at[530,'Longitude']
centerOfRegions[7,0] = test_dataset.at[1200,'Latitude'] # cluster 3
centerOfRegions[7,1] = test_dataset.at[1200,'Longitude'] 
centerOfRegions[8,0] = test_dataset.at[2200,'Latitude'] # cluster 5
centerOfRegions[8,1] = test_dataset.at[2200,'Longitude']
centerOfRegions[9,0] = test_dataset.at[3200,'Latitude'] # cluster 7
centerOfRegions[9,1] = test_dataset.at[3200,'Longitude']
centerOfRegions[10,0] = test_dataset.at[4700,'Latitude'] # cluster 10
centerOfRegions[10,1] = test_dataset.at[4700,'Longitude']
centerOfRegions[11,0] = test_dataset.at[5200,'Latitude'] # cluster 11
centerOfRegions[11,1] = test_dataset.at[5200,'Longitude']
centerOfRegions[12,0] = test_dataset.at[6200,'Latitude'] # cluster 13
centerOfRegions[12,1] = test_dataset.at[6200,'Longitude'] 
centerOfRegions[13,0] = test_dataset.at[8200,'Latitude'] # cluster 17
centerOfRegions[13,1] = test_dataset.at[8200,'Longitude']
centerOfRegions[14,0] = test_dataset.at[9200,'Latitude'] # cluster 19
centerOfRegions[14,1] = test_dataset.at[9200,'Longitude']
centerOfRegions[15,0] = test_dataset.at[9700,'Latitude'] # cluster 20
centerOfRegions[15,1] = test_dataset.at[9700,'Longitude']
centerOfRegions[16,0] = test_dataset.at[11700,'Latitude'] # cluster 24
centerOfRegions[16,1] = test_dataset.at[11700,'Longitude']
centerOfRegions[17,0] = test_dataset.at[12200,'Latitude'] # cluster 25
centerOfRegions[17,1] = test_dataset.at[12200,'Longitude']
centerOfRegions[18,0] = test_dataset.at[12700,'Latitude'] # cluster 26
centerOfRegions[18,1] = test_dataset.at[12700,'Longitude']
centerOfRegions[19,0] = test_dataset.at[13200,'Latitude'] # cluster 27
centerOfRegions[19,1] = test_dataset.at[13200,'Longitude']

#centerOfRegions = np.array([test_dataset.at[14150]['Latitude'], test_dataset.at[14150]['Longitude']])

noOfClusters = len(centerOfRegions)
m = folium.Map(location = [40.915568, -73.699215], tiles = "Stamen Toner")
m_BEST = folium.Map(location = [40.915568, -73.699215], tiles = "Stamen Toner")
#for i in range(noOfClusters):
#	folium.Marker([centerOfRegions[i][0], centerOfRegions[i][1]], popup = (str(np.round(centerOfRegions[i][0], 2))+", "
#		+str(np.round(centerOfRegions[i][1], 2)))).add_to(m)
#m.save("Anomalous_regions_centers.html")

# BEST sMAPE
p1 = centerOfRegions[0,:]
folium.Marker(p1, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(7,20),
        html='<div style="font-size: 18pt; color : red">1</div>',
        )).add_to(m)
m.add_child(folium.CircleMarker(p1, radius=15))

p2 = centerOfRegions[1,:]
folium.Marker(p2, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(7,20),
        html='<div style="font-size: 18pt; color : red">4</div>',
        )).add_to(m)
m.add_child(folium.CircleMarker(p2, radius=18))

p3 = centerOfRegions[2,:]
folium.Marker(p3, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(7,20),
        html='<div style="font-size: 18pt; color : red">9</div>',
        )).add_to(m)
m.add_child(folium.CircleMarker(p3, radius=18))

p4 = centerOfRegions[3,:]
folium.Marker(p4, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">16</div>',
        )).add_to(m)
m.add_child(folium.CircleMarker(p4, radius=18))

p5 = centerOfRegions[4,:]
folium.Marker(p5, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">28</div>',
        )).add_to(m)
m.add_child(folium.CircleMarker(p5, radius=18))

p6 = centerOfRegions[5,:]
folium.Marker(p6, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">29</div>',
        )).add_to(m)
m.add_child(folium.CircleMarker(p6, radius=18))

m.save("Anomalous_regions_centers.html", pdi = 300)





# WORST sMAPE
p7 = centerOfRegions[6,:]
folium.Marker(p7, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">2</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p7, radius=18))


p8 = centerOfRegions[7,:]
folium.Marker(p8, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(7,15),
        html='<div style="font-size: 15pt; color : red">3</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p8, radius=18))

p9 = centerOfRegions[8,:]
folium.Marker(p9, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(7,15),
        html='<div style="font-size: 15pt; color : red">5</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p9, radius=18))

p10 = centerOfRegions[9,:]
folium.Marker(p10, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">7</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p10, radius=18))

p11 = centerOfRegions[10,:]
folium.Marker(p11, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">10</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p11, radius=18))

p12 = centerOfRegions[11,:]
folium.Marker(p12, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">11</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p12, radius=18))

p13 = centerOfRegions[12,:]
folium.Marker(p13, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">13</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p13, radius=18))

p14 = centerOfRegions[13,:]
folium.Marker(p14, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">17</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p14, radius=18))

p15 = centerOfRegions[14,:]
folium.Marker(p15, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">19</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p15, radius=18))

p16 = centerOfRegions[15,:]
folium.Marker(p16, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">20</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p16, radius=18))

p17 = centerOfRegions[16,:]
folium.Marker(p17, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">24</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p17, radius=18))

p18 = centerOfRegions[17,:]
folium.Marker(p18, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">25</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p18, radius=18))

p19 = centerOfRegions[18,:]
folium.Marker(p19, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">26</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p19, radius=18))

p20 = centerOfRegions[19,:]
folium.Marker(p20, icon=DivIcon(
        icon_size=(150,36),
        icon_anchor=(10,15),
        html='<div style="font-size: 15pt; color : red">27</div>',
        )).add_to(m_BEST)
m_BEST.add_child(folium.CircleMarker(p20, radius=18))

m_BEST.save("Good_regions_centers.html", pdi = 300)